clc
warning off
%% Parameters
nEig = 100;
magnitude = 30;
random_def = 1;
comp = 69;
%% Load the aligned models
if ~exist('alignedModels_lin','var')
    load('data/alignedModels_bh_1779_lin.mat')
end
%% Build the average model
m = mean(alignedModels_lin,2);
avgModel = reshape(m,3,20112/3)';
load('data/avgModel_bh_1779_NE.mat')
plot_mesh(avgModel,compute_delaunay(avgModel));
pause
close

%% Center the data
alignedModels_centerd = alignedModels_lin - repmat(m,1,1779);

%% Apply PCA
if ~exist('components','var')
    
    disp('applying PCA')
    [components, ~, evals] = pca_dollar(alignedModels_centerd,1);
    components = components(:,1:nEig);
    evals = evals(1:nEig);
end
%% Perform Random Deformations
if random_def
    alpha = rand(size(components,2),1);
    alpha = rescale(alpha, -magnitude, magnitude);
else
    alpha = zeros(size(components,2),1);
    alpha(comp) = magnitude;
end

%% sum_1:n(alpha_i*w_i): alpha is column vector
dim = size(components,1)/3;
alpha_full = repmat(alpha',size(components,1),1);
tmp_eigen = alpha_full.*components;
sumVec = sum(tmp_eigen,2);
sumMat = reshape(sumVec',3,dim);

%%  S = m + sum_1:n(alpha_i*w_i)
defShape = avgModel + sumMat';

subplot(1,3,1)
plot_mesh(avgModel,compute_delaunay(avgModel));
title('Average Model')
subplot(1,3,2)
plot_mesh(defShape,compute_delaunay(defShape));
title('Deformed Model')
subplot(1,3,3)
show3DFaceHeatMap(avgModel,defShape)
title('Heatmap')
pause
close
