addpath(genpath('.'));
if ~exist('imgTest','var')
    load('data/imgTest.mat')
    load('data/components_DL_300.mat')
    Components = full(Components);
    Components_res = [];
    for c=1:size(Components,2)
        comp = Components(:,c)';
        comp = reshape(comp',3,size(Components,1)/3)';
        Components_res(:,:,c)=comp;
    end
    % Rendering parameters
    rp     = defrp;
    rp.phi = 0.5;
    rp.dir_light.dir = [0;1;1];
    rp.dir_light.intens = 0.6*ones(3,1);
    disp('Data loaded')
end

%% some params
PLOT_ON =1;
rem_bound = 0;
rounds = 1;
r = 3;
C_dist = 700;
renderingStep = 0.5;

%% reload iLandmarks3D everytime
load('data/avgModel_bh_1779_NE.mat')
if rem_bound
    idxLandmarks3D(1:17) = [];
    landmarks3D(1:17,:) = [];
end

lambda_opt = 0.09;
for s = 1:size(imgTest,2)
    disp(['Image n ' num2str(s)])
    % load test image and landmarks
    landImage = imgTest(s).landImage;
    if ~isempty(landImage)
        landImage(65,:) = [];
        landImage(61,:) = [];
        if rem_bound
            landImage(1:17,:) = [];
        end
        img_c = imgTest(s).img;

        [A, S, R, t,defShape,alpha,err,err_avg,visIdx] = opt_3DMM_fast(Weights,Components_res,Components,...
            landmarks3D,idxLandmarks3D,landImage,avgModel,lambda_opt,rounds,r,C_dist);
        % project the model onto image and sample RGB ----------------------
        projShape = getProjectedVertex(defShape,S,R,t)';
        tic;
        [frontalView, mod3d, colors] = renderFaceLossLess_2(defShape,projShape,img_c,S,R,t,renderingStep,visIdx);
        disp(['Elasped rendering time:  ' num2str(toc)])
        % project the 3D model vertices on the frontal rendering -----------
        projModelOnRend = getLandmarkPosition(defShape',defShape,renderingStep);
        projLandOnRend = getLandmarkPosition(defShape',defShape(idxLandmarks3D,:),renderingStep);
        if PLOT_ON
            figure(1);clf
            subplot(1,2,1)
            plot_landmarks(img_c, projShape,'r.',0)
            hold on
            plot(landImage(:,1),landImage(:,2),'gx')
            subplot(1,2,2)
            plot_mesh(defShape,compute_delaunay(defShape));
            shading flat
            figure;
            display_face_janus(mod3d, (colors')*255, compute_delaunay(mod3d)', rp);
            pause
            close all
        end
        
    end
end



